
#pragma once

// for debug
#ifdef _DEBUG
	const bool _Mtl_DialogKiller_traceOn = true;
	#define dgkTRACE if (_Mtl_DialogKiller_traceOn) ATLTRACE
#else
	#define dgkTRACE
#endif

// I never trust IE's interfaces.
class CDialogKiller
{
public:
	static HHOOK s_hCreateHook;
	static bool s_bValid;

	static bool IsInstalled()
	{
		return (s_hCreateHook != NULL);
	}

	static void Validate(bool bValid = true)
	{
		s_bValid = bValid;
	}

	static void InstallDialogKiller()
	{
		if (s_hCreateHook == NULL) {
			s_hCreateHook = ::SetWindowsHookEx(WH_CBT, CreateHookProc, _Module.GetModuleInstance(), GetCurrentThreadId());
			ATLASSERT(s_hCreateHook != NULL);
		}
	}

	static void UninstallDialogKiller()
	{
		if (s_hCreateHook != NULL)
			::UnhookWindowsHookEx(s_hCreateHook);

		s_hCreateHook = NULL;
	}

	static void OnDialogCreate(HWND hWndDlg)
	{
		CString str = MtlGetWindowText(hWndDlg);
		dgkTRACE(_T("OnDialogCreate\n"));
		CWindow wndDlg(hWndDlg);

		wndDlg.ModifyStyle(WS_VISIBLE, 0, SWP_NOACTIVATE);
		wndDlg.PostMessage(WM_COMMAND, MAKEWPARAM(IDCANCEL, 0));
		wndDlg.PostMessage(WM_COMMAND, MAKEWPARAM(IDOK, 0));
	}

	static void OnTridentDlgFrameCreate(HWND hWndDlg)
	{	
		CWindow wndDlg(hWndDlg);
		dgkTRACE(_T("OnTridentDlgFrameCreate\n"));
		DWORD dwStyle = wndDlg.GetStyle();
		if (dwStyle & WS_POPUPWINDOW) {
			dgkTRACE(_T(" kill the IE trident dialog!\n"));
			wndDlg.ModifyStyle(WS_VISIBLE, 0, SWP_NOACTIVATE);
//			wndDlg.PostMessage(WM_KEYDOWN, VK_RETURN);
			wndDlg.PostMessage(WM_CLOSE);
		}

//		The window don't have text yet.
//		if (str.Find(_T("XNvg")) != -1 && str.Find(_T("G[")) != -1) {
//			dgkTRACE(_T(" kill the IE trident dialog!\n"));

//			wndDlg.ModifyStyle(WS_VISIBLE, 0, SWP_NOACTIVATE);
//			wndDlg.PostMessage(WM_KEYDOWN, VK_ESCAPE);
//			wndDlg.PostMessage(WM_CLOSE);
//		}
	}

// Implementation - Hook procs
	static LRESULT CALLBACK CreateHookProc(int nCode, WPARAM wParam, LPARAM lParam)
	{
		LRESULT lRet = 0;

		if (nCode == HCBT_CREATEWND)
		{
			if (!s_bValid)
				return lRet;

			HWND hWndDlg = (HWND)wParam;

			TCHAR szClassName[40];
			::GetClassName(hWndDlg, szClassName, 40);
			dgkTRACE(_T("DialogKiller - HCBT_CREATEWND (%s)\n"), szClassName);

			if(!lstrcmp(_T("#32770"), szClassName))
				OnDialogCreate(hWndDlg);
			else if (!lstrcmp(_T("Internet Explorer_TridentDlgFrame"), szClassName))
				OnTridentDlgFrameCreate(hWndDlg);
		}
		else if(nCode < 0)
		{
			lRet = ::CallNextHookEx(s_hCreateHook, nCode, wParam, lParam);
		}

		return lRet;
	}
};

class CDialogKillerLock
{
public:
	bool m_bInstallReally;

	CDialogKillerLock()
	{
		CDialogKiller::Validate(false);
	}

	~CDialogKillerLock()
	{
		CDialogKiller::Validate(true);
	}
};

__declspec(selectany) HHOOK CDialogKiller::s_hCreateHook = NULL;
__declspec(selectany) bool CDialogKiller::s_bValid = true;