#ifndef __MTLBASE_H__
#define __MTLBASE_H__

#pragma once
////////////////////////////////////////////////////////////////////////////
// MTL Version 0.10
// Copyright (C) 2001 MB<mb2@geocities.co.jp>
// All rights unreserved.
//
// This file is a part of Mb Template Library.
// The code and information is *NOT* provided "as-is" without
// warranty of any kind, either expressed or implied.
//
// MtlBase.h: Last updated: March 17, 2001
////////////////////////////////////////////////////////////////////////////
namespace MTL
{
////////////////////////////////////////////////////////////////////////////
// ATL forgot 
#ifdef _DEBUG
	#define MTLVERIFY(f) if (!f) ATLASSERT(FALSE)
#else
	#define MTLVERIFY(f) ((void)(f))
#endif

// for ATL array
#ifndef _countof
	#define _countof(array) (sizeof(array)/sizeof(array[0]))
#endif

#define _begin(x) x.GetSize() == 0 ? NULL : &x[0]
#define _end(x) x.GetSize() == 0 ? NULL : &x[0]+x.GetSize()

template <typename T>
inline BOOL MtlSetSimpleArraySize(CSimpleArray<T>& arrSrc, int nSize)
{
	if (nSize > arrSrc.m_nAllocSize)
	{
		T* aT;
		int nNewAllocSize = nSize;
		aT = (T*)::realloc(arrSrc.m_aT, nNewAllocSize * sizeof(T));
		if(aT == NULL)
			return FALSE;
		arrSrc.m_nAllocSize = nNewAllocSize;
		arrSrc.m_aT = aT;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Tips
template <typename _Type1, typename _Type2>
inline bool _check_flag(_Type1 __flag, _Type2 __flags)
{
	if (__flags & __flag)
		return true;
	else
		return false;
//	return (__flags & __flag);
}

template <typename _VersionalBySize>
class CVersional : public _VersionalBySize
{
public:
	CVersional()
	{
		cbSize = sizeof(_VersionalBySize);
	}
};

template <>
class CVersional<WINDOWPLACEMENT> : public WINDOWPLACEMENT
{
public:
	CVersional()
	{
		length = sizeof(WINDOWPLACEMENT);
	}
};

struct CLockStaticDataInit
{
	CLockStaticDataInit() { ::EnterCriticalSection(&_Module.m_csStaticDataInit); }

	~CLockStaticDataInit() { ::LeaveCriticalSection(&_Module.m_csStaticDataInit); }
};

struct CLockWindowCreate
{
	CLockWindowCreate() { ::EnterCriticalSection(&_Module.m_csWindowCreate); }

	~CLockWindowCreate() { ::LeaveCriticalSection(&_Module.m_csWindowCreate); }
};

// Menu animation flags
#ifndef TPM_VERPOSANIMATION
	#define TPM_VERPOSANIMATION 0x1000L
#endif
#ifndef TPM_NOANIMATION
	#define TPM_NOANIMATION 0x4000L
#endif
////////////////////////////////////////////////////////////////////////////
} // namespace MTL;

#ifndef _MTL_NO_AUTOMATIC_NAMESPACE
using namespace MTL;
#endif //!_MTL_NO_AUTOMATIC_NAMESPACE

#endif // __MTLBASE_H__