#ifndef __MTLWEB_H__
#define __MTLWEB_H__

// MTL Version 1.01
// Copyright (C) 2000 MB<mb2@geocities.co.jp>
// All rights unreserved.
//
// This file is a part of Mb Template Library.
// The code and information is *NOT* provided "as-is" without
// warranty of any kind, either expressed or implied.
//
// Last updated: July 05, 2000

#pragma once

#ifndef __MTLMISC_H__
	#error mtlweb.h requires mtlmisc.h to be included first
#endif

#ifndef _WININET_
	#error mtlweb.h requires wininet.h to be included first
#endif

#ifndef _INC_SHLWAPI
	#error mtlweb.h requires shlwapi.h to be included first
#endif

#ifndef __INTSHCUT_H__
	#error mtlweb.h requires intshcut.h to be included first
#endif

#include <algorithm>
#include <list>

namespace MTL
{

inline bool MtlGetFavoritesFolder(CString& rString)
{
	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER,
		_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"));
	if(lRet != ERROR_SUCCESS)
		return false;

	TCHAR szRetString[MAX_PATH];
	DWORD dwCount = MAX_PATH * sizeof(TCHAR);
	lRet = rk.QueryValue(szRetString, _T("Favorites"), &dwCount);
	if(lRet != ERROR_SUCCESS) {
		rk.Close();
		lRet = rk.Open(HKEY_CURRENT_USER,
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"));
		if (lRet != ERROR_SUCCESS)
			return false;
		lRet = rk.QueryValue(szRetString, _T("Favorites"), &dwCount);
		if (lRet != ERROR_SUCCESS)
			return false;
	}
	rk.Close();

	TCHAR szRetString2[MAX_PATH];
	::ExpandEnvironmentStrings(szRetString, szRetString2, MAX_PATH);
	rString = szRetString2;
	ATLTRACE2(atlTraceUser, 4, _T("MTL: MtlGetFavoritesFolder : %s\n"), szRetString2);
	return true;
}

inline bool MtlGetHistoryFolder(CString& rString)
{
	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER,
		_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"));
	if(lRet != ERROR_SUCCESS)
		return false;

	TCHAR szRetString[MAX_PATH];
	DWORD dwCount = MAX_PATH * sizeof(TCHAR);
	lRet = rk.QueryValue(szRetString, _T("History"), &dwCount);
	if(lRet != ERROR_SUCCESS) {
		rk.Close();
		lRet = rk.Open(HKEY_CURRENT_USER,
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"));
		if (lRet != ERROR_SUCCESS)
			return false;
		lRet = rk.QueryValue(szRetString, _T("History"), &dwCount);
		if (lRet != ERROR_SUCCESS)
			return false;
	}
	rk.Close();

	TCHAR szRetString2[MAX_PATH];
	::ExpandEnvironmentStrings(szRetString, szRetString2, MAX_PATH);
	rString = szRetString2;
	ATLTRACE2(atlTraceUser, 4, _T("MTL: MtlGetFavoritesFolder : %s\n"), szRetString2);
	return true;
}

inline bool MtlGetFavoriteLinksFolder(CString& rString)
{// inspired by DOGSTORE
	if (!MtlGetFavoritesFolder(rString))
		return false;

	MtlMakeSureTrailingBackSlash(rString);

	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Internet Explorer\\Toolbar"));
	if (lRet == ERROR_SUCCESS) {
		TCHAR szName[MAX_PATH];
		DWORD dwCount = MAX_PATH * sizeof(TCHAR);
		lRet = rk.QueryValue(szName, _T("LinksFolderName"), &dwCount);
		if (lRet == ERROR_SUCCESS) {
			TCHAR szName2[MAX_PATH];
			::ExpandEnvironmentStrings(szName, szName2, MAX_PATH);
			rString += szName2;
			MtlMakeSureTrailingBackSlash(rString);
			return true;
		}
	}

	rString += _T("N\\");
	return false;
}

bool MtlCreateInternetShortcutFile(const CString& strFileName, const CString& strUrl)
{// Thanks to <http://www.nt.sakura.ne.jp/~miwaki/>
	CComPtr<IUniformResourceLocator> spUrl;
    HRESULT hr = ::CoCreateInstance(CLSID_InternetShortcut, NULL,
                CLSCTX_ALL, IID_IUniformResourceLocator, (void**)&spUrl);
	if (FAILED(hr))
		return false;

	CComPtr<IPersistFile> spPf;
	hr = spUrl->QueryInterface(IID_IPersistFile, (void**)&spPf);
	if (FAILED(hr))
		return false;

	hr = spUrl->SetURL(strUrl, 0);
	if (FAILED(hr))
		return false;

	USES_CONVERSION;
	hr = spPf->Save(T2COLE((LPCTSTR)strFileName), TRUE);
	if (FAILED(hr))
		return false;

	return true;
}


// Note. If the third parameter is "CString strPath", it rarely crash. why?
inline void MtlOrganizeFavorite(HWND hWnd, bool bOldShell = false, const CString& strPath_ = _T(""))
{
/*	Wrong code: dialog can't handle mouse message
	CComPtr<IShellUIHelper> spShell;
	HRESULT hr = spShell.CoCreateInstance(CLSID_ShellUIHelper, NULL);
	if (SUCCEEDED(hr)) {
	//	CComVariant v1, v2;
	//	CComBSTR bstr(OLESTR("OrganizeFavorites"));
	//	HRESULT hr = spShell->ShowBrowserUI(bstr, &v1, NULL);//&v2);
		CComVariant v1(OLESTR("OrganizeFavorites"));
		CComDispatchDriver driver(spShell);
		hr = driver.Invoke1(0x0000000d, &v1, NULL);
		if (FAILED(hr)) {
			CString strPath;
			if (MBtlGetFavoriteDirectory(strPath)) {
				::ShellExecute(0, "open", "explorer.exe", strPath, ".", SW_SHOW);
			}
		}
	}
*/
	// get favorite path
	CString strPath(strPath_);
	if (strPath.IsEmpty())
		MtlGetFavoritesFolder(strPath);

	if (bOldShell) {
		// easy way
		//::ShellExecute(NULL, NULL, strPath, NULL, NULL, SW_SHOWNORMAL);
		// UDT DGSTR ( diplay Explorer bar )
		::ShellExecute( NULL , _T("open") , _T("explorer.exe") , _T("/e, ") + strPath, NULL , SW_SHOW);
		// ENDE
		return;
	}

	HINSTANCE hLib = ::LoadLibrary(_T("shdocvw.dll"));
	if (hLib) {
		typedef UINT (CALLBACK* LPFNORGFAV)(HWND, LPTSTR);
		LPFNORGFAV lpfnDoOrganizeFavDlg = (LPFNORGFAV)::GetProcAddress(hLib, "DoOrganizeFavDlg");
		if (lpfnDoOrganizeFavDlg) {
			TCHAR szPath[MAX_PATH];
			::lstrcpy(szPath, strPath);
			(*lpfnDoOrganizeFavDlg)(hWnd, szPath);
		}
		::FreeLibrary(hLib);
		// a following fails if old shell (not support ::SHGetSpecialFolderPath)
		// TCHAR szPath[MAX_PATH];
		// HRESULT hr = ::SHGetSpecialFolderPath(m_hWnd, szPath, CSIDL_FAVORITES, TRUE);
		// if (SUCCEEDED(hr)) {
		//	lpfnDoOrganizeFavDlg(m_hWnd, strPath);
		// }

		// We must rebuild the menu each time because
		// DoOrganizeFavDlg doesn't indicate if nothing 
		// was changed.
		// BeginWaitCursor();
		// BuildFavoritesMenu();   // Rebuild all the favorites links
		// EndWaitCursor();
	}
	else {
		// easy way
		::ShellExecute(NULL, NULL, strPath, NULL, NULL, SW_SHOWNORMAL);
	}
}

inline bool __MtlAddFavoriteOldShell(const CString& strUrl, const CString& strName_, const CString& strFavDir)
{
	// easy way for old shell users
	static const TCHAR szFilter[] = _T("URLt@C(*.url)\0*.url\0\0");
	TCHAR szOldPath[MAX_PATH];// save current directory
	::GetCurrentDirectory(MAX_PATH, szOldPath);
	
	::SetCurrentDirectory(strFavDir);

	CString strName(strName_);
	MtlValidateFileName(strName);

	CFileDialog fileDlg(FALSE, _T("url"), strName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	fileDlg.m_ofn.lpstrInitialDir = strFavDir;
	fileDlg.m_ofn.lpstrTitle = _T("Cɓɒǉ");

	if (fileDlg.DoModal() == IDOK) {
		CString strFile(fileDlg.m_szFileName);
		CString strExt = strFile.Right(4);
		if (!MtlIsExt(strFile, _T(".url")))
			strFile += _T(".url");

		::WritePrivateProfileString(_T("InternetShortcut"), _T("URL"),
					 strUrl, strFile);
	}
	::SetCurrentDirectory(szOldPath);

	return true;
}

inline bool _MtlAddFavoriteNewShell(const CString& strUrl, const CString& strName)
{
	CComPtr<IShellUIHelper> spShell;
	HRESULT hr = spShell.CoCreateInstance(CLSID_ShellUIHelper);
	if (FAILED(hr))
		return false;

	CComBSTR bstrName(strName);
	CComBSTR bstrUrl(strUrl);
	CComVariant vt(bstrName);
	hr = spShell->AddFavorite(bstrUrl, &vt);
	if (FAILED(hr))
		return false;

	return true;
}

inline bool _MtlAddFavoriteModalSucks(const CString& strUrl, const CString& strName_,
									  const CString& strFavPath, HWND hWnd)
{
	CString strName(strName_);
	MtlValidateFileName(strName);

	bool bResult = false;
//	NOTE. Some buttons can't be validate. I'm fed up with IE.]
	typedef BOOL (CALLBACK* LPFNADDFAV)(HWND, LPTSTR, UINT, LPTSTR, UINT, LPITEMIDLIST);
 	HMODULE hMod = (HMODULE)::LoadLibrary(_T("shdocvw.dll"));
	if (hMod) {
		LPFNADDFAV lpfnDoAddToFavDlg = (LPFNADDFAV)::GetProcAddress(hMod, "DoAddToFavDlg");
		if (lpfnDoAddToFavDlg) {
			int nLen = strName.GetLength();
			LPTSTR szName = (LPTSTR)_alloca((nLen+1)*sizeof(TCHAR));
			::lstrcpy(szName, strName);

			TCHAR szPath[MAX_PATH];
			CItemIDList idlFavPath = strFavPath;
			BOOL bOK = lpfnDoAddToFavDlg(hWnd,
				szPath, _countof(szPath),
                szName, nLen,
				idlFavPath);
			
			if (bOK)
				MtlCreateInternetShortcutFile(szPath, strUrl);

			bResult = true;
		}

		FreeLibrary(hMod);
	}

	return bResult;
}

inline bool MtlAddFavorite(const CString& strUrl, const CString& strName, bool bOldShell = false,
						   const CString& strFavDir_ = _T(""), HWND hWnd = NULL)
{// how complex...	
	CString strStdFavDir;
	if (!MtlGetFavoritesFolder(strStdFavDir))
		return false;

	CString strFavDir(strFavDir_);
	if (strFavDir.IsEmpty()) {
		strFavDir = strStdFavDir;
	}

	if (bOldShell) {
		return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}

	bool bStdFavDir = (strStdFavDir == strFavDir);

	if (bStdFavDir) {
		if (!_MtlAddFavoriteNewShell(strUrl, strName))
			return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}
	else {
		if (!_MtlAddFavoriteModalSucks(strUrl, strName, strFavDir, hWnd))
			return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}

	return false;
}

#pragma comment( lib, "wininet" )
// cf.MSDN "Offline Browsing"
// Bug: Even if an user is working-Offline before your application runs, 
//      this function always returns FALSE.
inline bool MtlIsGlobalOffline()
{
	DWORD dwState = 0, dwSize = sizeof(DWORD);
	bool bRet = false;

	if(::InternetQueryOption(NULL, INTERNET_OPTION_CONNECTED_STATE, &dwState, &dwSize)) {
		if(dwState & INTERNET_STATE_DISCONNECTED_BY_USER)
			bRet = true;
	}

	return bRet; 
}

// cf.MSDN "Offline Browsing"
inline void MtlSetGlobalOffline(bool bGoOffline)
{
	if (MtlIsGlobalOffline() == bGoOffline)
		return;

	INTERNET_CONNECTED_INFO ci;
	memset(&ci, 0, sizeof(ci));
	if(bGoOffline) {
		ci.dwConnectedState = INTERNET_STATE_DISCONNECTED_BY_USER;
		ci.dwFlags = ISO_FORCE_DISCONNECTED;
	} 
	else {
		ci.dwConnectedState = INTERNET_STATE_CONNECTED;
	}

	::InternetSetOption(NULL, INTERNET_OPTION_CONNECTED_STATE, &ci, sizeof(ci));
}
// UDT DGSTR ( Thx 2 JOBBY )
	BOOL GetSecure(DWORD Action){
		HRESULT hRet;
		IInternetZoneManager *pZoneMgr;
		DWORD Policy;
		// char str[128];
		int ret;

		// create instance IInternetZoneManager
		hRet = CoCreateInstance(CLSID_InternetZoneManager, NULL, CLSCTX_INPROC_SERVER,
					IID_IInternetZoneManager, (void**)&pZoneMgr);
		if(SUCCEEDED(hRet)){
			// get security policy
			hRet = pZoneMgr->GetZoneActionPolicy( URLZONE_INTERNET,
						Action, (BYTE*)&Policy, sizeof(Policy), URLZONEREG_DEFAULT);
			if(SUCCEEDED(hRet)){
				ret=Policy;
			}else{
				// error
				ret=-1;
			}
			pZoneMgr->Release();
		}else{
			// error
			ret=-1;
		}
		CoFreeUnusedLibraries();
		return ret;
	}

	BOOL SetSecure(DWORD Action, DWORD policy)
	{
		HRESULT hRet;
		IInternetZoneManager *pZoneMgr;
		ZONEATTRIBUTES ZoneAttrib;

		// char str[128];
		BOOL ret;

		// create instance IInternetZoneManager
		hRet = CoCreateInstance(CLSID_InternetZoneManager, NULL, CLSCTX_INPROC_SERVER,
					IID_IInternetZoneManager, (void**)&pZoneMgr);
		if(SUCCEEDED(hRet)){
			// change security policy
			hRet = pZoneMgr->SetZoneActionPolicy(URLZONE_INTERNET,
						Action, (BYTE*)&policy, sizeof(policy), URLZONEREG_DEFAULT);
			if(SUCCEEDED(hRet)){
				// set security level custom
				// now the method is applied 
				ZoneAttrib.cbSize=sizeof(ZoneAttrib);
				hRet = pZoneMgr->GetZoneAttributes(URLZONE_INTERNET, &ZoneAttrib);
				if(SUCCEEDED(hRet)){
					ZoneAttrib.dwTemplateCurrentLevel=URLTEMPLATE_CUSTOM;
					hRet = pZoneMgr->SetZoneAttributes(URLZONE_INTERNET, &ZoneAttrib);
					if(SUCCEEDED(hRet)){
						ret=TRUE;
					}else{
						ret=FALSE;
					}
				}else{
					ret=FALSE;
				}
			}else{
				// error
				ret=FALSE;
			}
			pZoneMgr->Release();
		}else{
			// error
			ret=FALSE;
		}
		CoFreeUnusedLibraries();
		return ret;
	}
// ENDE
// UDT DGSTR
// Is IE over v5.5 ?
inline BOOL IsIEOver(void)
{
	TCHAR szIEVersion[MAX_PATH];
	DWORD dwCount = MAX_PATH * sizeof(TCHAR);	
	// Get IE Version
	CRegKey rk;
	LONG lRet = rk.Open(HKEY_LOCAL_MACHINE,
		_T("SOFTWARE\\Microsoft\\Internet Explorer"), KEY_QUERY_VALUE);
	if (lRet == ERROR_SUCCESS )
		rk.QueryValue(szIEVersion, _T("Version"), &dwCount);
	else
		return FALSE;
	rk.Close();
	if (lstrlen(szIEVersion) == 0)
		return FALSE;
	// suck..
	double f = atof(szIEVersion);
	if ( f >= 5.5 )
		return TRUE;
	return FALSE;
}
// ENDE
// UDT DGSTR
BOOL ChangeSecure( DWORD dwFlag , BOOL bOn )
{
	if ( dwFlag == DLCTL_NO_RUNACTIVEXCTLS )
		SetSecure(URLACTION_ACTIVEX_RUN, bOn ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	else if ( dwFlag == DLCTL_NO_DLACTIVEXCTLS )
		SetSecure(URLACTION_DOWNLOAD_SIGNED_ACTIVEX , bOn ? URLPOLICY_QUERY : URLPOLICY_DISALLOW);
	else if ( dwFlag == DLCTL_NO_SCRIPTS )
		SetSecure(URLACTION_SCRIPT_RUN, bOn ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW);
	else if ( dwFlag == DLCTL_NO_JAVA )
		SetSecure(URLACTION_JAVA_PERMISSIONS, bOn ? URLPOLICY_JAVA_HIGH : URLPOLICY_JAVA_PROHIBIT);

	return TRUE;
}
// ENDE
#if (_WIN32_IE >= 0x0500)
inline bool MtlAutoComplete(HWND hWnd)
{
	bool bRet = false;
	HINSTANCE hLib = ::LoadLibrary(_T("shlwapi.dll"));
	if (hLib) {
		typedef HRESULT (CALLBACK *LPFNSHAUTOCOMPLETE)(HWND hWnd, DWORD dw);
		LPFNSHAUTOCOMPLETE lpfnSHAutoComplete = (LPFNSHAUTOCOMPLETE)::GetProcAddress(hLib, "SHAutoComplete");
		if (lpfnSHAutoComplete) {
			HRESULT hr = (*lpfnSHAutoComplete)(hWnd, SHACF_FILESYSTEM | SHACF_URLALL | SHACF_USETAB);
			if (SUCCEEDED(hr))
				bRet = true;
		}
		::FreeLibrary(hLib);
	}

	return bRet;
}
#endif

inline MtlShowInternetOptions()
{// this is modeless
	::ShellExecute(0, _T("open"), _T("control.exe"), _T("inetcpl.cpl"), _T("."), SW_SHOW);
}

bool MtlGetShortCutUrl(CString& strFilePath)
{
	CString strExt = strFilePath.Right(4);

	if (strExt.CompareNoCase(_T(".url")) != 0)
		return false;

	TCHAR szUrl[INTERNET_MAX_PATH_LENGTH];
	::GetPrivateProfileString(_T("InternetShortcut"), _T("URL"),
		  _T(""), szUrl, INTERNET_MAX_PATH_LENGTH, strFilePath);

	CString strUrl(szUrl);
	if (strUrl.IsEmpty())
		return false;

	strFilePath = strUrl;
	return true;
}

inline bool MtlCreateShortCutFile(const CString& strFile, const CString& strTarget,
					   const CString& strDescription = _T(""), const CString& strArgs = _T(""),
					   const CString& strWorkingDir = _T(""), const CString& strIconPath = _T(""),
					   int iIcon = 0, int iShowCmd = SW_SHOWNORMAL)	// EBhEX^C
{// Thanks to <http://www.nt.sakura.ne.jp/~miwaki/>
	if (MtlIsExt(strTarget, _T(".url")) || MtlIsExt(strTarget, _T(".lnk"))) {
		// if target is .lnk or .url, just copy!!
		CString strFolder = MtlGetDirectoryPath(strFile, true);
		CString strTarget_ = strTarget;
		CSimpleArray<CString> arrFiles; arrFiles.Add(strTarget_);
		return MtlCopyFile(strFolder, arrFiles);
	}

	CComPtr<IShellLink> spLink;
	HRESULT hr = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_ALL, IID_IShellLink, (void**)&spLink);
	if (FAILED(hr))
		return false;

	CComPtr<IPersistFile> spFile;
	hr = spLink->QueryInterface(IID_IPersistFile, (void**)&spFile);
	if (FAILED(hr))
		return false;


	spLink->SetPath(strTarget);

	if (!strDescription.IsEmpty())
		spLink->SetDescription(strDescription);
	if (!strArgs.IsEmpty())
		spLink->SetArguments(strArgs);
	if (!strWorkingDir.IsEmpty())
		spLink->SetWorkingDirectory(strWorkingDir);
	if (!strIconPath.IsEmpty())
		spLink->SetIconLocation(strIconPath, iIcon);

	spLink->SetShowCmd(iShowCmd);

	USES_CONVERSION;
	hr = spFile->Save(T2COLE((LPCTSTR)strFile), TRUE);
	if (FAILED(hr))
		return false;

	return true;
}


bool MtlPreOpenFile(CString& strPath, const CString& strArg = CString())
{
	ATLTRACE(_T("MtlPreOpenFile(%s)\n"), strPath);

	if (MtlIsExt(strPath, _T(".exe"))) {
		::ShellExecute(NULL, _T("open"), strPath, strArg, NULL, SW_SHOWNORMAL);
		return true;// handled
	}

	if (!MtlIsExt(strPath, _T(".lnk")))
		return false;// not handled

	CComPtr<IShellLink> spShellLink;
	// Create IShellLink Objec
	HRESULT hr = ::CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_ALL, IID_IShellLink, (void **)&spShellLink);
	if (FAILED(hr))
		return false;

	CComQIPtr<IPersistFile> spPersistFile(spShellLink);
	if (spPersistFile) {
		// load shortcut
		USES_CONVERSION;
		hr = spPersistFile->Load(T2COLE(strPath), STGM_READ);
		if (SUCCEEDED(hr)) {
			// get link
			TCHAR szFilePath[MAX_PATH];
			WIN32_FIND_DATA wfd;
			hr = spShellLink->GetPath(szFilePath, MAX_PATH, &wfd, SLGP_UNCPRIORITY);
			if (FAILED(hr))
				return false;

			if (!MtlIsExt(szFilePath, _T(".exe"))) {
				strPath = szFilePath;
				return false;
			}

			TCHAR szCmdLine[2048]; szCmdLine[0] = _T('\0');
			hr = spShellLink->GetArguments(szCmdLine, 2048);

			if (!strArg.IsEmpty())
				::lstrcpyn(szCmdLine, strArg, 2048);

			int nShowCmd = SW_SHOWNORMAL;
			hr = spShellLink->GetShowCmd(&nShowCmd);

			TCHAR szDirPath[MAX_PATH]; szDirPath[0] = _T('\0');
			hr = spShellLink->GetWorkingDirectory(szDirPath, 2048);

			::ShellExecute(NULL, _T("open"), szFilePath, szCmdLine, szDirPath, nShowCmd);
			return true;// handled
		}
	}

	return false;
}

// Undocumented command ids
static const CLSID CGID_IWebBrowser = {0xED016940L,0xBD5B,0x11cf,0xBA, 0x4E,0x00,0xC0,0x4F,0xD7,0x08,0x16};
#define HTMLID_FIND 1
#define HTMLID_VIEWSOURCE 2
#define HTMLID_OPTIONS 3

template <class T>
class CWebBrowserCommandHandler
{
public:
// Message map and handlers
	BEGIN_MSG_MAP(CWebBrowserCommandHandler)
		COMMAND_ID_HANDLER_EX(ID_FILE_SAVE_AS, OnFileSaveAs)
		COMMAND_ID_HANDLER_EX(ID_FILE_PAGE_SETUP, OnFilePageSetup)
		COMMAND_ID_HANDLER_EX(ID_FILE_PRINT, OnFilePrint)
		COMMAND_ID_HANDLER_EX(ID_FILE_PRINTPREVIEW, OnFilePrintPreview) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_FILE_PROPERTIES, OnFileProperties)
		COMMAND_ID_HANDLER_EX(ID_EDIT_CUT, OnEditCut)
		COMMAND_ID_HANDLER_EX(ID_EDIT_COPY, OnEditCopy)
		COMMAND_ID_HANDLER_EX(ID_EDIT_PASTE, OnEditPaste)
		COMMAND_ID_HANDLER_EX(ID_EDIT_FIND, OnEditFind)
		COMMAND_ID_HANDLER_EX(ID_EDIT_SELECT_ALL, OnEditSelectAll)
		COMMAND_ID_HANDLER_EX(ID_VIEW_BACK, OnViewBack)

		COMMAND_ID_HANDLER_EX(ID_EDIT_TITLE_COPY, OnEditTitleCopy) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_EDIT_URL_COPY, OnEditURLCopy) // UDT DGSTR

		COMMAND_ID_HANDLER_EX(ID_EDIT_FIND_MAX, OnEditFindMax) // UDT DGSTR

		COMMAND_ID_HANDLER_EX(ID_EDIT_OPEN_SELECTED, OnEditOpenSeleceted) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_EDIT_OPEN_LINK_ALL, OnEditOpenLinkAll) // UDT DGSTR

		COMMAND_ID_HANDLER_EX(ID_BACK_ONE, OnViewBack) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_BACK_TWO, OnViewBack) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_BACK_THREE, OnViewBack) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_BACK_FOUR, OnViewBack) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_BACK_FIVE, OnViewBack) // UDT DGSTR

		COMMAND_ID_HANDLER_EX(ID_VIEW_FORWARD, OnViewForward)

		COMMAND_ID_HANDLER_EX(ID_FORWARD_ONE, OnViewForward) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_FORWARD_TWO, OnViewForward) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_FORWARD_THREE, OnViewForward) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_FORWARD_FOUR, OnViewForward) // UDT DGSTR
		COMMAND_ID_HANDLER_EX(ID_FORWARD_FIVE, OnViewForward) // UDT DGSTR
		
		COMMAND_ID_HANDLER_EX(ID_VIEW_SOURCE_SELECTED , OnViewSourceSelected) // UDT DGSTR

		COMMAND_ID_HANDLER_EX(ID_VIEW_REFRESH, OnViewRefresh)
		COMMAND_ID_HANDLER_EX(ID_VIEW_STOP, OnViewStop)
		COMMAND_ID_HANDLER_EX(ID_VIEW_HOME, OnViewHome)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_LARGEST, OnViewFontLargest)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_LARGER, OnViewFontLarger)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_MEDIUM, OnViewFontMedium)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_SMALLER, OnViewFontSmaller)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_SMALLEST, OnViewFontSmallest)
		COMMAND_ID_HANDLER_EX(ID_VIEW_SOURCE, OnViewSource)
		COMMAND_ID_HANDLER_EX(ID_VIEW_OPTION, OnViewOption)
	END_MSG_MAP()
// UDT DGSTR
// CString::Find is fucked up ..
	int _Find(const CString& str, int nStart, const CString& strFind)
	{
		CString strText = str.Right(str.GetLength() - nStart);
		int nIndex = strText.Find(strFind);
		if (nIndex == -1)
			return -1;
		else {
			return nStart + nIndex;
		}
	}

	void parseHTML(const CString& strHTMLText, const CString& strLocationURL , WORD wID)
	{
		T* pT = static_cast<T*>(this);
		int i = 1;
		int j;

		CString strBuf;
		while (0 < i)
		{
			i= _Find(strHTMLText , i , _T("href=") );
			if (0 < i) 
				i = i + lstrlen(_T("href="));
			else break;
			
			strBuf = strHTMLText.Mid(i, 1);
			if ((lstrcmp(strBuf , _T("\"")) == 0) || (lstrcmp(strBuf,"'") == 0))
				j = _Find(strHTMLText , i + 1 ,strBuf);
			else 
			{
				j = _Find(strHTMLText , i + 1 , _T(" "));
				if ( j > _Find(strHTMLText , i , _T(">")) )
						j = _Find(strHTMLText , i , _T(">"));
			}

			strBuf = strHTMLText.Mid( i + 1 , j - (i + 1));
			
			if (lstrcmp(_T("http"), strBuf.Left(4)) != 0)
			{
				if ( !lstrcmp(_T("/"), strBuf.Left(1)) )
				{
					// Virtual Directory 
					strBuf = strLocationURL.Mid(0 , _Find(strLocationURL , lstrlen(_T("https://")) -1 , _T("/") ) ) + strBuf;
				}
				else 
				{
					// Relative Path
					if ( strLocationURL.ReverseFind('/') > strLocationURL.ReverseFind('\\') )
						strBuf = strLocationURL.Mid(0, strLocationURL.ReverseFind('/') +1 )+ strBuf;
					else
						strBuf = strLocationURL.Mid(0, strLocationURL.ReverseFind('\\') +1)+ strBuf;
				}
			}
			strBuf.Replace(_T("&amp;") , _T("&")); // Replace &amp;
			DonutOpenFile(pT->m_hWnd, strBuf,DonutGetStdOpenCreateFlag());
			i = j;
		}
	}

	void viewSelectedSource(const CString& strHTMLText)
	{
		if (strHTMLText.IsEmpty())
			return;
		T* pT = static_cast<T*>(this);
		// get tmp path & create tmp file
		TCHAR sztmpFileName[MAX_PATH];
		CString strTempPath = MtlGetModuleFileName();
		strTempPath = strTempPath.Left(strTempPath.ReverseFind('\\')) + _T("\\ShortcutTmp\\");
		CreateDirectory(strTempPath, NULL);

		DWORD dwAccBytes;
		::GetTempFileName(strTempPath , _T("dnr") , 0 , sztmpFileName);
		HANDLE hFile = ::CreateFile(sztmpFileName , GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_TEMPORARY, NULL);
		::WriteFile(hFile , strHTMLText , strHTMLText.GetLength() , &dwAccBytes , NULL);
		::CloseHandle(hFile);

		// get editor path
		CRegKey rk;
		LONG lRet = rk.Open(HKEY_LOCAL_MACHINE,
			_T("SOFTWARE\\Microsoft\\Internet Explorer\\View Source Editor\\Editor Name"), KEY_QUERY_VALUE);
		TCHAR szEditorName[MAX_PATH] = "notepad.exe";
		DWORD dwCount = MAX_PATH * sizeof(TCHAR);
		if (lRet == ERROR_SUCCESS )
		{
			lRet = rk.QueryValue(szEditorName, NULL, &dwCount);
		}
		rk.Close();
		ShellExecute(pT->m_hWnd , _T("open") , szEditorName , sztmpFileName , 0 , SW_SHOW);	
		// i cannot use CreateProcess for checking Exit code, coz i cannnot check it ,in case using src Handling tool.
	}

	void parseFramesCollection(CComPtr<IDispatch> pDisp , WORD wID)
	{
		BSTR bstrHTML;
		BSTR bstrLocation;
		T* pT = static_cast<T*>(this);
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;
		CComQIPtr<IHTMLFramesCollection2, &IID_IHTMLFramesCollection2> spFrameCollection;
		spHTML = pDisp;
		HRESULT hr = spHTML->get_frames(&spFrameCollection);
		if ( hr != S_OK ) 
			return;
		LONG lFrameLength;
		spFrameCollection->get_length(&lFrameLength);
		for (LONG i = 0; i < lFrameLength; i++)
		{
			CComQIPtr<IHTMLWindow2, &IID_IHTMLWindow2> spHTMLWindow;
			CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spNextHTML;
			CComQIPtr<IHTMLSelectionObject, &IID_IHTMLSelectionObject> spNextSelection;
			CComQIPtr<IHTMLTxtRange, &IID_IHTMLTxtRange> spNextTextRange;
			CComQIPtr<IHTMLLocation, &IID_IHTMLLocation> spHTMLLocation;
			CComPtr<IDispatch> pDispNext, pDispBack;

			VARIANT varResult;
			VARIANT varItem;
			varItem.vt = VT_I4;
			varItem.lVal = i;
			spFrameCollection->item(&varItem, &varResult);
			spHTMLWindow = varResult.pdispVal;
			if (spHTMLWindow) 
			{
				spHTMLWindow->get_document(&spNextHTML);
				if (spNextHTML)
				{
					spNextHTML->get_selection(&spNextSelection);
					spNextSelection->createRange(&pDispNext);
					spNextTextRange = pDispNext;
					if (spNextTextRange)
					{
						if ( wID == ID_EDIT_OPEN_SELECTED )
						{
							spNextTextRange->get_text(&bstrHTML);
							if (bstrHTML)
								DonutOpenFile(pT->m_hWnd, bstrHTML,DonutGetStdOpenCreateFlag());
						}
						else if ( wID == ID_EDIT_FIND_MAX )
						{
							spNextTextRange->get_text(&bstrHTML);
							if (bstrHTML)
								searchEngines(bstrHTML);
						}
						else if ( wID == ID_EDIT_OPEN_LINK_ALL )
						{
							spNextTextRange->get_htmlText(&bstrHTML);
							spHTMLWindow->get_location(&spHTMLLocation);
							spHTMLLocation->get_href(&bstrLocation);
							if (bstrHTML) 
								parseHTML( bstrHTML, bstrLocation, wID);
						}
						else if ( wID == ID_VIEW_SOURCE_SELECTED )
						{
							spNextTextRange->get_htmlText(&bstrHTML);
							if (bstrHTML) 
								viewSelectedSource(bstrHTML);
						}
					}
					else 
					{
						pDispBack = spNextHTML;
						parseFramesCollection(pDispBack , wID);
					}
				}
			}
		}
	}
	void OnEditOpenSeleceted(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		BSTR bstrHTML;
		T* pT = static_cast<T*>(this);
		CComPtr<IDispatch> pDisp , pDisp2;
		CComQIPtr<IHTMLSelectionObject, &IID_IHTMLSelectionObject> spSelection;
		CComQIPtr<IHTMLTxtRange, &IID_IHTMLTxtRange> spTextRange; 
		HRESULT hr = pT->m_spBrowser->get_Document(&pDisp);
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;
		spHTML = pDisp;
		if (spHTML) 
		{
			spHTML->get_selection(&spSelection);
			spSelection->createRange(&pDisp2);
			spTextRange = pDisp2;
			if (spTextRange) // Non Frame && GetSelection
			{  
				spTextRange->get_text(&bstrHTML);
				if (bstrHTML)
					DonutOpenFile(pT->m_hWnd, bstrHTML,DonutGetStdOpenCreateFlag());
				else 
					parseFramesCollection(pDisp , wID);
			}
			else 
			{
				parseFramesCollection(pDisp , wID);
			}
		} 
	}
	void searchEngines(const CString& strKeyWord )
	{
		T* pT = static_cast<T*>(this);
		CString strURL;
		int nMaxCount = 15;
		TCHAR szGoogleCode[INTERNET_MAX_PATH_LENGTH] = 
				"http://www.google.com/search?lr=lang_ja&q=";
		CIniSection pr;
		pr.Open(_szIniFileName, _T("INUYA"));
		TCHAR szRetString[INTERNET_MAX_PATH_LENGTH];
		TCHAR szBuff[9];
		for(int nItem = 0; nItem < nMaxCount; nItem++)
		{
			wsprintf(szBuff, _T("Engine%i"), nItem);
			DWORD dwCount = INTERNET_MAX_PATH_LENGTH * sizeof(TCHAR);
			if(pr.QueryValue(szRetString, szBuff, &dwCount) == ERROR_SUCCESS )
			{
				strURL = szRetString + strKeyWord;
				DonutOpenFile(pT->m_hWnd, strURL,DonutGetStdOpenCreateFlag());
			}
			else 
			{
				if ( nItem == 0 )
				{
					strURL = szGoogleCode + strKeyWord;
					DonutOpenFile(pT->m_hWnd, strURL,DonutGetStdOpenCreateFlag());
				}
				break;
			}
		}
			pr.Close();
	}
	void OnEditFindMax(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{	
		BSTR bstrHTML;
		T* pT = static_cast<T*>(this);
		CComPtr<IDispatch> pDisp , pDisp2;
		CComQIPtr<IHTMLSelectionObject, &IID_IHTMLSelectionObject> spSelection;
		CComQIPtr<IHTMLTxtRange, &IID_IHTMLTxtRange> spTextRange; 
		HRESULT hr = pT->m_spBrowser->get_Document(&pDisp);
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;
		spHTML = pDisp;
		if (spHTML) 
		{
			spHTML->get_selection(&spSelection);
			spSelection->createRange(&pDisp2);
			spTextRange = pDisp2;
			if (spTextRange) // Non Frame && GetSelection
			{  
				spTextRange->get_text(&bstrHTML);
				if (bstrHTML)
					searchEngines(bstrHTML);

				else 
					parseFramesCollection(pDisp , wID);
			}
			else 
			{
				parseFramesCollection(pDisp , wID);
			}
		}
	}
	void OnEditOpenLinkAll(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		BSTR bstrHTML;
		T* pT = static_cast<T*>(this);
		CComPtr<IDispatch> pDisp , pDisp2;
		CComQIPtr<IHTMLSelectionObject, &IID_IHTMLSelectionObject> spSelection;
		CComQIPtr<IHTMLTxtRange, &IID_IHTMLTxtRange> spTextRange; 
		HRESULT hr = pT->m_spBrowser->get_Document(&pDisp);
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;
		spHTML = pDisp;
		if (spHTML) 
		{
			spHTML->get_selection(&spSelection);
			spSelection->createRange(&pDisp2);
			spTextRange = pDisp2;
			if (spTextRange) // Non Frame && GetSelection
			{  
				spTextRange->get_htmlText(&bstrHTML);
				if (bstrHTML) 
					parseHTML( bstrHTML, pT->GetLocationURL() , wID);
				else 
					parseFramesCollection(pDisp , wID);
			}
			else 
			{
				parseFramesCollection(pDisp , wID);
			}
		} 
	}

	void OnViewSourceSelected(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		BSTR bstrHTML;
		T* pT = static_cast<T*>(this);
		CComPtr<IDispatch> pDisp , pDisp2;
		CComQIPtr<IHTMLSelectionObject, &IID_IHTMLSelectionObject> spSelection;
		CComQIPtr<IHTMLTxtRange, &IID_IHTMLTxtRange> spTextRange; 
		HRESULT hr = pT->m_spBrowser->get_Document(&pDisp);
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;
		spHTML = pDisp;
		if (spHTML) 
		{
			spHTML->get_selection(&spSelection);
			spSelection->createRange(&pDisp2);
			spTextRange = pDisp2;
			if (spTextRange) // Non Frame && GetSelection
			{  
				spTextRange->get_htmlText(&bstrHTML);
				if (bstrHTML) 
					viewSelectedSource(bstrHTML);
				else 
					parseFramesCollection(pDisp , wID);
			}
			else 
					parseFramesCollection(pDisp , wID);
		} 
	}
// ENDE
	void OnFileSaveAs(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFilePageSetup(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PAGESETUP, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFilePrint(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	// UDT DGSTR
	void OnFilePrintPreview(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	// ENDE
	void OnFileProperties(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PROPERTIES, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditCut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{	
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_CUT, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	// UDT DGSTR
	void OnEditTitleCopy( WORD , WORD , HWND )
	{
		T* pT = static_cast<T*>(this);
		MtlSetClipboardText(MtlGetWindowText(pT->m_hWnd));
	}
	void OnEditURLCopy( WORD , WORD , HWND )
	{
		T* pT = static_cast<T*>(this);
		MtlSetClipboardText(pT->GetLocationURL());
	}
	// ENDE
	void OnEditCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_COPY, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditPaste(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PASTE, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_FIND, 0, NULL, NULL);
		// this is just file search
		//	m_spBrowser->ExecWB(OLECMDID_FIND, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditSelectAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_SELECTALL, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}

	void OnViewBack(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoBack();
		// UDT DGSTR
		int nIndex = 0;
		// never break
		switch (wID)
		{
			case ID_BACK_FIVE:
				nIndex++;
			case ID_BACK_FOUR:
				nIndex++;
			case ID_BACK_THREE:
				nIndex++;
			case ID_BACK_TWO:
				nIndex++;
				break;
		}
		for ( int i = 0; i < nIndex; i++ )
			pT->m_spBrowser->GoBack();
		// ENDE
	}
	void OnViewForward(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoForward();
		// UDT DGSTR
		int nIndex = 0;
		// never break
		switch (wID)
		{
			case ID_FORWARD_FIVE:
				nIndex++;
			case ID_FORWARD_FOUR:
				nIndex++;
			case ID_FORWARD_THREE:
				nIndex++;
			case ID_FORWARD_TWO:
				nIndex++;
				break;
		}
		for ( int i = 0; i < nIndex; i++ )
			pT->m_spBrowser->GoForward();
		// ENDE
	}
	void OnViewRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->Refresh();
	}
	void OnViewStop(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->Stop();
	}
	void OnViewHome(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoHome();
	}
	void OnViewOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_OPTIONS, 0, NULL, NULL);
		// this is modeless
		// ::ShellExecute(0, "open", "control.exe", "inetcpl.cpl", ".", SW_SHOW);
	}
	
	// zoom font
	void OnViewFontLargest(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(4L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontLarger(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(3L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontMedium(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(2L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontSmaller(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(1L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontSmallest(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(0L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}

	void OnViewSource(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_VIEWSOURCE, 0, NULL, NULL);
	}
};

template <class T>
class CMDIFrameTitleUpsideDownMessageHandlerWeb
{
public:
	bool m_bValid;
	CString m_strWorkOffline;
	CString m_strStatusBar; // UDT DGSTR

	CMDIFrameTitleUpsideDownMessageHandlerWeb() : m_bValid(true), m_strWorkOffline(_T(" - [ItC]")), m_strStatusBar(_T("")) // UDT DGSTR
	{
	}

	void UpdateTitleBarUpsideDown()
	{
		if (m_bValid) {
			CString strApp; strApp.LoadString(IDR_MAINFRAME);
			T* pT = static_cast<T*>(this);
			pT->SetWindowText(strApp);
		}
	}
	// UDT DGSTR
	void UpdateTitleBarUpsideDown(const CString& strStatusBar)
	{
		m_strStatusBar = strStatusBar;
		if (m_bValid) {
			CString strApp; strApp.LoadString(IDR_MAINFRAME);
			T* pT = static_cast<T*>(this);
			pT->SetWindowText(strApp);
		}
	}
	// ENDE
	BEGIN_MSG_MAP(CMDIFrameTitleUpsideDownMessageHandlerWeb)
		MESSAGE_HANDLER(WM_GETTEXTLENGTH, OnGetTextLength)
		MESSAGE_HANDLER(WM_GETTEXT, OnGetText)
	END_MSG_MAP()

	LRESULT OnGetTextLength(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		return pT->DefWindowProc(uMsg, wParam, lParam) + m_strWorkOffline.GetLength() + 1;
	}

	LRESULT OnGetText(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		UINT cchTextMax = (UINT)wParam;   // number of characters to copy 
		LPTSTR lpszText = (LPTSTR)lParam;

		if (!m_bValid) {
			bHandled = FALSE;
			return 0;
		}

		T* pT = static_cast<T*>(this);

		CString strApp; strApp.LoadString(IDR_MAINFRAME);
		CString strTitle;
		BOOL bMaximized = FALSE;
		HWND hWndActive = pT->MDIGetActive(&bMaximized);
		if (hWndActive == NULL || bMaximized == FALSE)
			strTitle = strApp;
		// UDT DGSTR ( Set Information on TitleBar.
		else if ( !IsWindowVisible(pT->m_hWndStatusBar) )
		{			
			if(!m_strStatusBar.IsEmpty())
				strTitle = MtlGetWindowText(hWndActive) + _T(" - ") + m_strStatusBar;
			else
				strTitle = MtlGetWindowText(hWndActive) /*+ _T(" - ") + strApp*/;
		}
		// ENDE
		else
			strTitle = MtlGetWindowText(hWndActive) + _T(" - ") + strApp;

		if (MtlIsGlobalOffline())
			strTitle += m_strWorkOffline;

		::lstrcpyn(lpszText, strTitle, cchTextMax);	

		bHandled = TRUE;
		return min(strTitle.GetLength(), cchTextMax);
	}
};

CString MtlMakeFavoriteToolTipText(const CString& strName_, const CString& strUrl_, int cchTextMax)
{
	CString strName = MtlCompactString(strName_, cchTextMax);

	if (strUrl_.IsEmpty())
		return strName;

	CString strUrl;
	bool bRet = MtlCompactPath(strUrl, strUrl_, cchTextMax - strName.GetLength() - 1);// consider _('\n') too

	if (!bRet || strName == strUrl)
		return strName;
	else
		return strName + _T('\n') + strUrl;
}


template <class TKey>
class CSimpleMapInt : public CSimpleMap<TKey, int>
{
public:
	int Lookup(TKey key) const
	{
		int nIndex = FindKey(key);
		if(nIndex == -1)
			return -1;
		return GetValueAt(nIndex);
	}
};

// I thought this is the best, but it seems that
// idls which means the same path don't surely have the same bits. 
//typedef CSimpleMapInt< CAdapt<CItemIDList> > CFavoritesOrder;

typedef CSimpleMapInt< CString > CFavoritesOrder;

// Thanks to fub and namazu
typedef struct _tagCFavoritesOrderData
{
	DWORD size;
	DWORD priority;
	ITEMIDLIST idl; // relative idlist
} _CFavoritesOrderData;

void MtlGetFavoritesOrder(CFavoritesOrder& order, const CString& strDirPath)
{
	ATLASSERT(!strDirPath.IsEmpty());
	const s_unknownOffset = 12;

	CString strRoot;
	if (!MtlGetFavoritesFolder(strRoot))
		return;
	MtlMakeSureTrailingBackSlash(strRoot);
	
	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	CString strRelative = strDirPath.Right(strDirPath.GetLength() - strRoot.GetLength());
	if (!strRelative.IsEmpty())
		strKeyName += _T('\\') + strRelative;

	MtlRemoveTrailingBackSlash(strKeyName);
//	ATLTRACE(_T(" strKeyName(%s)\n"), strKeyName);

	CRegKey rkOrder;
	LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, strKeyName);
	if (lRet != ERROR_SUCCESS)
		return;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
	if (lRet != ERROR_SUCCESS || dwSize < s_unknownOffset)
		return;

	BYTE* pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
	::memset(pByte, 0, dwSize+10);

	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
	if (lRet != ERROR_SUCCESS)
		return;

	BYTE* pBegin = pByte + ((_CFavoritesOrderData*)pByte)->size + s_unknownOffset;
	BYTE* pEnd = pByte + dwSize;

	while (pBegin < pEnd) {
		_CFavoritesOrderData* pData = (_CFavoritesOrderData*)pBegin;
		CItemIDList idl(&pData->idl);
		CString strName = MtlGetFileName(idl.GetPath());
		if (!strName.IsEmpty()) {
//			ATLTRACE(_T("order(%s, %d)\n"), strName, pData->priority);
			order.Add(strName, pData->priority);
		}

		pBegin += pData->size;
	}
}
/*
void MtlGetFavoritesOrder(CFavoritesOrder& order, const CString& strDirPath)
{
	ATLASSERT(!strDirPath.IsEmpty());
	const s_unknownOffset = 12;

	CString strRoot;
	if (!MtlGetFavoritesFolder(strRoot))
		return;
	MtlMakeSureTrailingBackSlash(strRoot);
	
	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	CString strRelative = strDirPath.Right(strDirPath.GetLength() - strRoot.GetLength());
	if (!strRelative.IsEmpty())
		strKeyName += _T('\\') + strRelative;

	MtlRemoveTrailingBackSlash(strKeyName);
//	ATLTRACE(_T(" strKeyName(%s)\n"), strKeyName);

	CRegKey rkOrder;
	LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, strKeyName);
	if (lRet != ERROR_SUCCESS)
		return;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
	if (lRet != ERROR_SUCCESS || dwSize < s_unknownOffset)
		return;

	BYTE* pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
	::memset(pByte, 0, dwSize+10);

	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
	if (lRet != ERROR_SUCCESS)
		return;

	BYTE* pBegin = pByte + ((_CFavoritesOrderData*)pByte)->size + s_unknownOffset;
	BYTE* pEnd = pByte + dwSize;

	while (pBegin < pEnd) {
		_CFavoritesOrderData* pData = (_CFavoritesOrderData*)pBegin;
		CItemIDList idl(&pData->idl);
		order.Add(idl, pData->priority);
		pBegin += pData->size;
	}
}
*/
}  //namespace MTL

#endif // __MTLWEB_H__